﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Web.Services
Imports System.Configuration

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindDummyItem()
        End If
    End Sub

    Private Sub BindDummyItem()
        Dim dummy As New DataTable()
        dummy.Columns.Add("Id")
        dummy.Columns.Add("Name")
        dummy.Columns.Add("Url")
        Dim count As Integer = If(dlImages.RepeatColumns = 0, 1, dlImages.RepeatColumns)
        For i As Integer = 0 To count - 1
            dummy.Rows.Add()
        Next
        dlImages.DataSource = dummy
        dlImages.DataBind()
    End Sub

    <WebMethod()> _
    Public Shared Function GetImages(pageIndex As Integer) As String
        Return GetImagesData(pageIndex).GetXml()
    End Function

    Public Shared Function GetImagesData(pageIndex As Integer) As DataSet
        Dim pageSize As Integer = 9
        Dim query As String = "[GetImagesPageWise]"
        Dim cmd As New SqlCommand(query)
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.AddWithValue("@PageIndex", pageIndex)
        cmd.Parameters.AddWithValue("@PageSize", pageSize)
        cmd.Parameters.Add("@PageCount", SqlDbType.Int, 4).Direction = ParameterDirection.Output
        Return GetData(cmd)
    End Function

    Private Shared Function GetData(cmd As SqlCommand) As DataSet
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(strConnString)
            Using sda As New SqlDataAdapter()
                cmd.Connection = con
                sda.SelectCommand = cmd
                Using ds As New DataSet()
                    sda.Fill(ds, "Images")
                    Dim dt As New DataTable("PageCount")
                    dt.Columns.Add("PageCount")
                    dt.Rows.Add()
                    dt.Rows(0)(0) = cmd.Parameters("@PageCount").Value
                    ds.Tables.Add(dt)
                    Return ds
                End Using
            End Using
        End Using
    End Function
End Class

